/***************************************************************************
                          abfrage.h  -  description
                             -------------------
    begin                : Tue Jan 18 2000
    copyright            : (C) 2000 by Friedrich W. H. Kossebau
    email                : Friedrich.W.H@Kossebau.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VABFRAGE_H
#define VABFRAGE_H

#include <qwidget.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlayout.h>
#include <kapp.h>

#include <qwidget.h>

#include "../vvokabel.h"
#include "vstring.h"
/**
  *@author Friedrich W. H. Kossebau
  */
  

class VAbfrage : public QFrame  
{
  Q_OBJECT
   
  public: 
  	VAbfrage( QWidget *parent=0, const char *name=0 );
  	~VAbfrage();
    void askAgain( QString Answer = 0, bool ShowLastInput = false, bool LetOnlyConfirm = false );
    void ask( QString GivenTerm );
    virtual QSize sizeHint() const;
    void setLanguage( int Line, const char *Language );
    
  protected: 
    /** sets the layout */
    void setLayout();
    /** switches label*/
    void setInputLabel();
    
  protected slots: // Public slots
    /** emits returnPressed */
    void finish();
    
  protected: 
  	QGridLayout Layout;
  	QLineEdit GivenText;
  	QLabel GivenColumn;
  	QLineEdit AskingLine;
  	QLabel AskedColumn;
  	QLabel LastTry;
  	
  	bool OnlyConfirmation;
  	  
  signals: // Signals
    void inputFinished( const QString & );
    void confirmed();
};

#endif
