/***************************************************************************
                          questsettingsedit.h  -  description
                             -------------------
    begin                : Wed Mar 08 2000
    copyright            : (C) 2000 by Friedrich W. H. Kossebau
    email                : Friedrich.W.H@Kossebau.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QUESTSETTINGSEDIT_H
#define QUESTSETTINGSEDIT_H

#include <qwidget.h>
#include <qgroupbox.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qcheckbox.h> 
#include <qdialog.h>

#include <kbuttonbox.h>

/**
  *@author Friedrich W. H. Kossebau
  */
struct VQuestionSettings;

class VQuestionDialog : public QDialog  {
   Q_OBJECT
  public: 
  	VQuestionDialog(QWidget *parent=0, const char *name=0);
  	~VQuestionDialog();
    /** opens the dialog and returns true if anything was modified 
      * TODO: if anything is default it will be selected to have quick deleting
      */
    void edit( VQuestionSettings *Settings );

  protected: 
    /** sets the layout */
    void setLayout();
  protected: 
    QVBoxLayout Layout; 
  	
  	// the group general
  	QGroupBox General;
    QVBoxLayout GeneralLayout;
    QCheckBox PartialCheck;
    QCheckBox SecondChanceCheck;
    QCheckBox ShowCorrectedInputCheck;
    QHBoxLayout CharacterLayout;
    QLineEdit UnknownCharacterEdit;
    QLabel UnknownCharacterLabel;
  	    
  	// button row at the bottom
    KButtonBox ButtonRow;
  	QPushButton *Cancel;
  	QPushButton *Ok;
  
  private: 
};

#endif
